package com.magnatune.eyecreate.companionformagnatune;

import android.app.Application;

import com.magnatune.eyecreate.companionformagnatune.api.MagnatuneAlbumsConverterFactory;
import com.magnatune.eyecreate.companionformagnatune.api.ToStringConverterFactory;
import com.magnatune.eyecreate.companionformagnatune.api.data_api;

import io.realm.RealmConfiguration;
import retrofit.Retrofit;

public class MagnatuneCompainionApplication extends Application {

    private static MagnatuneCompainionApplication instance;
    private static RealmConfiguration albumDBconfig;

    @Override
    public void onCreate() {
        super.onCreate();
        instance = this;
        albumDBconfig = new RealmConfiguration.Builder(instance)
                .name("albumDB")
                .build();
    }

    public static Application getApplication() {
        return instance;
    }

    public static data_api getDataApi() {
        Retrofit api = new Retrofit.Builder()
                .addConverterFactory(new MagnatuneAlbumsConverterFactory())
                .addConverterFactory(new ToStringConverterFactory())
                .baseUrl("http://he3.magnatune.com")
                .build();
        return api.create(data_api.class);
    }

    public static RealmConfiguration getAlbumDBConfig() {
        return instance.albumDBconfig;
    }
}
