package com.magnatune.eyecreate.companionformagnatune.fragments;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.Fragment;
import android.support.v4.content.LocalBroadcastManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.ProgressBar;

import com.magnatune.eyecreate.companionformagnatune.R;
import com.magnatune.eyecreate.companionformagnatune.service.PlayerService;
import com.magnatune.eyecreate.companionformagnatune.service.Playlist;

public class PlaylistFragment extends Fragment {

    ListView playlistUI;
    ProgressBar position;
    FloatingActionButton playPause;
    ImageButton prev;
    ImageButton next;
    Playlist playlist;

    //TODO:implement BRs
    BroadcastReceiver receivePlaylist = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    BroadcastReceiver playCalled = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    BroadcastReceiver pauseCalled = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    BroadcastReceiver playStarted = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    BroadcastReceiver nextCalled = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    BroadcastReceiver prevCalled = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    BroadcastReceiver trackQueued = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    BroadcastReceiver trackDequeued = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    BroadcastReceiver playlistCleared = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {

        }
    };

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View v = inflater.inflate(R.layout.fragment_playlist, container, false);
        playlistUI = (ListView) v.findViewById(R.id.list);
        position = (ProgressBar) v.findViewById(R.id.player_pos);
        playPause = (FloatingActionButton) v.findViewById(R.id.play_pause);
        prev = (ImageButton) v.findViewById(R.id.prev);
        next = (ImageButton) v.findViewById(R.id.next);
        //set up click events
        playPause.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent playPause = new Intent(getActivity(),PlayerService.class);
                if(playlist.isPaused()) {
                    playPause.setAction(PlayerService.ACTION_TRACK_PLAY);
                } else {
                    playPause.setAction(PlayerService.ACTION_TRACK_PAUSE);
                }
                getActivity().startService(playPause);
            }
        });
        prev.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent prev = new Intent(getActivity(),PlayerService.class);
                prev.setAction(PlayerService.ACTION_TRACK_PREV);
                getActivity().startService(prev);
            }
        });
        next.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if(isLastSong()) {
                    playlist.setPaused(true);
                    //TODO:have play button go back to paused state
                }
                Intent next = new Intent(getActivity(),PlayerService.class);
                next.setAction(PlayerService.ACTION_TRACK_NEXT);
                getActivity().startService(next);
            }
        });
        return v;
    }

    @Override
    public void onPause() {
        super.onPause();
        //Deregister BRs to prevent calling when no longer visible.
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(receivePlaylist);
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(playCalled);
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(pauseCalled);
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(playStarted);
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(nextCalled);
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(prevCalled);
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(trackQueued);
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(trackDequeued);
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(playlistCleared);
    }

    @Override
    public void onResume() {
        super.onResume();
        //Register BRs to act upon service calls.
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(receivePlaylist, new IntentFilter(PlayerService.ACTION_TRACK_LIST));
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(playCalled, new IntentFilter(PlayerService.ACTION_TRACK_PLAY));
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(pauseCalled, new IntentFilter(PlayerService.ACTION_TRACK_PAUSE));
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(playStarted, new IntentFilter(PlayerService.ACTION_PLAYING_STARTED));
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(nextCalled, new IntentFilter(PlayerService.ACTION_TRACK_NEXT));
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(prevCalled, new IntentFilter(PlayerService.ACTION_TRACK_PREV));
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(trackQueued, new IntentFilter(PlayerService.ACTION_TRACK_QUEUE));
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(trackDequeued, new IntentFilter(PlayerService.ACTION_TRACK_DEQUEUE));
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(playlistCleared, new IntentFilter(PlayerService.ACTION_PLAYLIST_CLEAR));
        //Request playlist from service to set up/sync rest of control data.
        Intent getPlaylist = new Intent(getActivity(),PlayerService.class);
        getPlaylist.setAction(PlayerService.ACTION_TRACK_LIST);
        getActivity().startService(getPlaylist);
    }

    private boolean isLastSong() {
        //TODO:implement
        return false;
    }

    //TODO:put in functions for buttons to send to player service and try to keep updated to it's state.
}
